/** 
 * <p>
 * DemeterF HTTP/Server related Classes/CDs.</p>
 * 
 * <p>
 * Simple classes for writing HTTP based client/servers.  We use annotations
 *   to mark a class as a {@link edu.neu.ccs.demeterf.http.server.Server Server}
 *   with a {@link edu.neu.ccs.demeterf.http.server.Port Port} number.
 * </p>
 * 
 * <p>
 * Methods are annotated with a {@link edu.neu.ccs.demeterf.http.server.Path Path}
 *   that describes the base path of requests that they will handle.  Handler methods
 *   must return an {@link edu.neu.ccs.demeterf.http.classes.HTTPResp HTTPResp}, and
 *   can accept: no arguments; one {@link edu.neu.ccs.demeterf.http.classes.HTTPReq HTTPReq}
 *   argument; or an HTTPReq followed by a {@link java.net.Socket Socket}.  The request
 *   (HTTPReq) describes the details (headers, path, body, etc.) while the Socket
 *   describes the connection.</p>
 * 
 * <p>See {@link edu.neu.ccs.demeterf.http.Test Test} for a simple Server
 * example, and http.cd/beh for more details.</p>
 */

package edu.neu.ccs.demeterf.http;